// ShioriThread.cpp: CRubyThread NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "RubyThread.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

HANDLE CRubyThread::m_evEndProcess = CreateEvent(NULL, TRUE, FALSE, "Mai_RubyThread_EndProcess");
DWORD CRubyThread::m_dwThreadHandle = NULL;
UINT CRubyThread::m_uiThreadID = NULL;
CRubyThread* CRubyThread::m_pThis = NULL;

CRubyThread::CRubyThread()
{
}

CRubyThread::~CRubyThread()
{

}

unsigned int __stdcall RubyThreadLoop(void* ptr)
{
	CRubyThread* pThreadClass = (CRubyThread*)ptr;
	// bZ[W҂[v
	MSG msg;

	for(;;) {
		Sleep(100);
		SetEvent(pThreadClass->m_evEndProcess);

		GetMessage( &msg, NULL, 0, 0 );

		if ( msg.message == WM_MAIRUBYTHREAD_INITIALIZE ) {
			pThreadClass->InitializeRuby((char*)msg.wParam);
		} else if ( msg.message == WM_MAIRUBYTHREAD_LOAD ) {
			*((BOOL*)msg.lParam) = pThreadClass->ThreadOnLoad(*((std::string*)msg.wParam));
		} else if ( msg.message == WM_MAIRUBYTHREAD_UNLOAD ) {
			*((BOOL*)msg.lParam) = pThreadClass->ThreadOnUnload();
		} else if ( msg.message == WM_MAIRUBYTHREAD_REQUEST ) {
			*((std::string*)msg.lParam) = pThreadClass->ThreadRequest(*((std::string*)msg.wParam));
		} else if ( msg.message == WM_MAIRUBYTHREAD_FINISH ) {
			break;
		} else {
//			ASSERT(0);
		}
	}
	SetEvent(pThreadClass->m_evEndProcess);
	return 0;
}

bool CRubyThread::StartThread(std::string& strPath)
{
	// XbhJn
	if (m_pThis)
		return false;
	m_pThis = new CRubyThread;
	ResetEvent(m_evEndProcess);
	m_dwThreadHandle = _beginthreadex(NULL, 0, RubyThreadLoop, m_pThis, 0/*CREATE_SUSPEND*/, &m_uiThreadID);
	::WaitForSingleObject(m_evEndProcess, INFINITE);
	ResetEvent(m_evEndProcess);

	Sleep(100);

	// RubyC^v^̏
	::PostThreadMessage(m_uiThreadID, WM_MAIRUBYTHREAD_INITIALIZE, (UINT)strPath.c_str(), 0);
	::WaitForSingleObject(m_evEndProcess, INFINITE);
	ResetEvent(m_evEndProcess);

	return true;
}

bool CRubyThread::EndThread()
{
	::PostThreadMessage(m_uiThreadID, WM_MAIRUBYTHREAD_FINISH, 0, 0);
	::WaitForSingleObject(m_evEndProcess, INFINITE);
	ResetEvent(m_evEndProcess);

	delete m_pThis;
	m_pThis = NULL;
	return true;
}

void CRubyThread::InitializeRuby(char* strPath)
{
	// C^v^
	ruby_init();

	// LibraryPATH
	std::string incpath = strPath;
	incpath += "rubylib";
	ruby_incpush(incpath.c_str());
	ruby_incpush((incpath+"\\cgi").c_str());
	ruby_incpush((incpath+"\\irb").c_str());
	ruby_incpush((incpath+"\\net").c_str());
	ruby_incpush((incpath+"\\uri").c_str());
	ruby_incpush((incpath+"\\shell").c_str());
	ruby_incpush((incpath+"\\i586-mswin32").c_str());

	// R[hݒ(SJIS)
	rb_eval_string("$KCODE='SJIS'");

	// WóEG[o͂t@CɌ
	{
		std::string ruby_script = "$> = File.new(\"";
		ruby_script += strPath;
		ruby_script += "ruby_console.txt\", \"w\")";
		// '\''\\'ɂȂƃ_ۂ
		std::string::size_type pos = ruby_script.find("\\");
		while (pos != std::string::npos) {
			ruby_script.replace(pos, 1, "\\\\");
			pos++;pos++;
			pos = ruby_script.find("\\", pos);
		}
		rb_eval_string(ruby_script.c_str());
		rb_eval_string("$>.sync=true");
		rb_eval_string("STDOUT = $>");
		rb_eval_string("STDERR = $>");
	}

	// Initiali Scriptǂݍ
	// rubỹt@Cǂݍł
	HANDLE file = NULL;

	std::string shiori_rb_path = strPath;
	shiori_rb_path += "shiori.rb";

	char *ruby_script = NULL;
	try {
		file = ::CreateFile(shiori_rb_path.c_str(), GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		if (!file)
			throw 0;

		DWORD filesize = ::GetFileSize(file, NULL);
		DWORD readsize;
		ruby_script = new char[filesize + 10];
		ZeroMemory(ruby_script, filesize + 10);
		::ReadFile(file, ruby_script, filesize, &readsize, NULL);
		::CloseHandle(file);
	} catch(...) {
		;
	}
	if (!ruby_script)
		return;

	try {
		rb_eval_string(ruby_script);
		delete [] ruby_script;
	} catch(...) {
		MessageBox(NULL, "shiori.rb̎sG[", "ruby error", MB_OK);
		delete [] ruby_script;
		return;
	}

	// Shiori Classinstance쐬
	g_shiori_instance = rb_eval_string("Shiori.new");
}

BOOL CRubyThread::OnLoad(std::string& str)
{
	BOOL retValue = TRUE;
	::PostThreadMessage(m_uiThreadID, WM_MAIRUBYTHREAD_LOAD, (WPARAM)&str, (LPARAM)&retValue);
	::WaitForSingleObject(m_evEndProcess, INFINITE);
	ResetEvent(m_evEndProcess);
	return retValue;
}

BOOL CRubyThread::OnUnload()
{
	BOOL retValue = TRUE;
	::PostThreadMessage(m_uiThreadID, WM_MAIRUBYTHREAD_UNLOAD, (WPARAM)0, (LPARAM)&retValue);
	::WaitForSingleObject(m_evEndProcess, INFINITE);
	ResetEvent(m_evEndProcess);
	return retValue;
}

std::string CRubyThread::Request(std::string& str)
{
	std::string retValue = "SHIORI/2.0 204 No Content\r\n\r\n";
	::PostThreadMessage(m_uiThreadID, WM_MAIRUBYTHREAD_REQUEST, (WPARAM)&str, (LPARAM)&retValue);
	::WaitForSingleObject(m_evEndProcess, INFINITE);
	ResetEvent(m_evEndProcess);
	return retValue;
}


BOOL CRubyThread::ThreadOnLoad(std::string& str)
{
	VALUE ret = rb_funcall(g_shiori_instance, rb_intern("load"), 1, rb_str_new2(str.c_str()));
	if (TYPE(ret) == T_TRUE)
		return TRUE;
	else
		return FALSE;
}

BOOL CRubyThread::ThreadOnUnload()
{
	VALUE ret = rb_funcall(g_shiori_instance, rb_intern("unload"), 0);
	if (TYPE(ret) == T_TRUE)
		return TRUE;
	else
		return FALSE;
}

std::string CRubyThread::ThreadRequest(std::string& str)
{
	VALUE ret = rb_funcall(g_shiori_instance, rb_intern("request"), 1, rb_str_new2(str.c_str()));
	if (TYPE(ret) == T_STRING)
		return std::string(RSTRING(ret)->ptr, RSTRING(ret)->len);
	else
		return "500 Internal Server Error\r\n\r\n";
}
